> For the complete documentation index, see [llms.txt](https://docs.fylr.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fylr.io/for-system-administrators/symptom-and-solution/containerconfig-error.md).

# ContainerConfig error

## Symptoms

When recreating a container, e.g. during an update, with docker-compose:

<pre><code><strong>Recreating postgresql ...
</strong>
<strong>ERROR: for postgresql  'ContainerConfig'
</strong>Traceback (most recent call last):
  File "/bin/docker-compose", line 33, in &#x3C;module>
    sys.exit(load_entry_point('docker-compose==1.29.2', 'console_scripts', 'docker-compose')())
             ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

[...]

    File "/usr/lib/python3/dist-packages/compose/service.py", line 1579, in get_container_data_volumes
    container.image_config['ContainerConfig'].get('Volumes') or {}
    ~~~~~~~~~~~~~~~~~~~~~~^^^^^^^^^^^^^^^^^^^
KeyError: 'ContainerConfig'
</code></pre>

## Causes

As far as we know, docker changed something so that `docker-compose` does not work with containers that were created with an older version `docker-compose`.<br>

But as `docker-compose` is considered <mark style="color:red;">deprecated</mark> and should be replaced with `docker compose` (note the missing `-` . It is now a plugin to `docker` instead of a stand-alone program named `docker-compose`), we just switch to `docker compose` instead of investigating the situation further with the deprecated `docker-compose`.

## Solutions

Stop and remove all running containers. For good measure you can also restart the docker service, but for us this was not needed in all cases.

Make sure the docker plugin for compose is installed. E.g. in the Debian package `docker-compose-plugin`.

Create all desired containers, but with `docker compose` instead of `docker-compose` (Note the difference: `-`)<br>

In our [recommended installation page](/for-system-administrators/installation/linux-docker-compose.md), we now recommend docker compose.

Our provided example maintain script now also uses docker compose, you can get the updated version like:

```
curl https://raw.githubusercontent.com/programmfabrik/fylr-gitbook/main/_assets/maintain -o maintain
chmod a+x maintain
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fylr.io/for-system-administrators/symptom-and-solution/containerconfig-error.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
